package com.brandwatch.microservice.client.helpers;

public class RemoteServiceDefinition {
    final String beanName;
    private final String serviceUrl;
    private final Class<?> serviceInterface;

    public RemoteServiceDefinition(String serviceUrl, Class<?> serviceInterface) {
        this.serviceUrl = serviceUrl;
        this.serviceInterface = serviceInterface;
        this.beanName = makeBeanName(serviceInterface.getSimpleName());
    }

    public RemoteServiceDefinition(String beanName, String serviceUrl, Class<?> serviceInterface) {
        this.beanName = beanName;
        this.serviceUrl = serviceUrl;
        this.serviceInterface = serviceInterface;
    }

    public String getBeanName() {
        return beanName;
    }

    public String getServiceUrl() {
        return serviceUrl;
    }

    public Class<?> getServiceInterface() {
        return serviceInterface;
    }

    private String makeBeanName(String className) {
        return className.substring(0, 1).toLowerCase() + className.substring(1);
    }

}
